package ru.dbotthepony.mc.otm.client.screen.tech

import net.minecraft.network.chat.Component
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.client.render.UVWindingOrder
import ru.dbotthepony.mc.otm.client.screen.MatteryScreen
import ru.dbotthepony.mc.otm.client.screen.panels.Dock
import ru.dbotthepony.mc.otm.client.screen.panels.DockResizeMode
import ru.dbotthepony.mc.otm.client.screen.panels.FramePanel
import ru.dbotthepony.mc.otm.client.screen.panels.SpritePanel
import ru.dbotthepony.mc.otm.client.screen.panels.button.DeviceControls
import ru.dbotthepony.mc.otm.client.screen.panels.slot.AbstractSlotPanel
import ru.dbotthepony.mc.otm.client.screen.panels.slot.MatterCapacitorSlotPanel
import ru.dbotthepony.mc.otm.client.screen.widget.HorizontalProfiledPowerGaugePanel
import ru.dbotthepony.mc.otm.client.screen.widget.ProgressGaugePanel
import ru.dbotthepony.mc.otm.menu.tech.EnergyHatchMenu
import ru.dbotthepony.mc.otm.menu.tech.MatterHatchMenu

class EnergyHatchScreen(menu: EnergyHatchMenu, inventory: Inventory, title: Component) : MatteryScreen<EnergyHatchMenu>(menu, inventory, title) {
	override fun makeMainFrame(): FramePanel<MatteryScreen<*>> {
		val frame = FramePanel(this, null, 0f, 0f, INVENTORY_FRAME_WIDTH, AbstractSlotPanel.SIZE, getTitle())

		frame.makeCloseButton()
		frame.onClose { onClose() }

		for (slot in menu.inputSlots) {
			val panel = MatterCapacitorSlotPanel(this, frame, slot)
			panel.dock = Dock.LEFT
			panel.dockResize = DockResizeMode.NONE
		}

		val arrow = SpritePanel(this, frame, ProgressGaugePanel.GAUGE_BACKGROUND)
		arrow.dockLeft = 2f
		arrow.dockRight = 2f
		arrow.dock = Dock.LEFT
		arrow.dockResize = DockResizeMode.NONE

		if (!menu.isInput)
			arrow.winding = UVWindingOrder.FLOP

		val gauge = HorizontalProfiledPowerGaugePanel(this, frame, menu.gauge)
		gauge.dock = Dock.RIGHT

		DeviceControls(this, frame, redstoneConfig = menu.redstone)

		return frame
	}
}
